import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    private int score; // used to make score possible
    
    private int time; // used to make a time limit possible
    
    public MyWorld()
    {    
        super(500, 300, 1); // used to create the world background and size
        
        prepare(); // used to add the targets and add the aiming tool
        
        score = 0; // used to hold the score variable in the world
        
        time = 700; // used to define the time limit
        
        showScore(); // method used to show the score
        
        showTime(); // method used to show the time limit
    }
    
    public void act()
    {
        countTime(); // used to countdown the time limit
    }
    
    public void prepare()
    {
        // adds the first target
        Target bullseye = new Target();
        addObject(bullseye, Greenfoot.getRandomNumber(500), Greenfoot.getRandomNumber(300)+10);
        
        // adds the second target
        Target bullseye2 = new Target();
        addObject(bullseye2, Greenfoot.getRandomNumber(500), Greenfoot.getRandomNumber(300)+10);
        
        // adds the third target
        Target bullseye3 = new Target();
        addObject(bullseye3, Greenfoot.getRandomNumber(500), Greenfoot.getRandomNumber(300)+10);
        
        // adds the aiming tool
        Aim aim = new Aim();
        addObject(aim, 250, 150);
    }
    
    public void showScore()
    {
        showText("Score: " + score, 50, 15); // used to add a visble scoreboard
    }
    
    public void addScore(int points)
    {
        score = score + points; // used to add score to the scoreboard
        
        showScore(); // used for the new score to display
    }
    
    public void countTime()
    {
        time--; // counts the time down
        
        showTime(); // used to show the time counting down
        
        if (time == 0) // used for the game to stop
        {
            showEndMessage(); // used to show the final score
            
            Greenfoot.stop(); // used so the program ends unless reset
        }
    }
    
    public void showTime()
    {
        showText("Time: " + time, 440, 15); // used to display the time
    }
    
    private void showEndMessage()
    {
        showText("Your final score: " + score + " points", 250, 150); // used to display the final score
    }
}
