import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Aim here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Aim extends Actor
{
    /**
     * Act - do whatever the Aim wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    public void act()
    {
        aimingMove(); // used so that the used can control the movement of aim actor
        
        targetShot(); // used so that sound is made when aim "shoots" a target and so that score is added to scoreboard
    }
    
    public void aimingMove()
    {
        if(Greenfoot.isKeyDown("left")) // allows the user to move the mouse leftwards
        {
            setLocation(getX()-3, getY());
        }
        
        if(Greenfoot.isKeyDown("right")) // allows the user to move the mouse rightwards
        {
            setLocation(getX()+3, getY());
        }
        
        if(Greenfoot.isKeyDown("up")) // allows the user to move the mouse upwards
        {
            setLocation(getX(), getY()-3);
        }
        
        if(Greenfoot.isKeyDown("down")) // allows the user to move the mouse downwards
        {
            setLocation(getX(), getY()+3);
        }
    }
    
    public void targetShot()
    {
        if(isTouching(Target.class)) // used so that aim interacts with the target actor when target is touched by aim
        {
            removeTouching(Target.class); // removes the target actor
            Greenfoot.playSound("StockGun.mp3"); // plays the stock sound effect from the sound files 
                                                 // so that it appears the target was "shot"
            
            Target target = new Target(); // used so that a new targat can be added 
            
            World world = (MyWorld)getWorld(); // used so that a new target can be added
                                               // and so that score can be added to the scoreboard
            
            world.addObject(target, Greenfoot.getRandomNumber(500), Greenfoot.getRandomNumber(300)+10); // used to add a new target in
                                                                                                        // a random location
            
            ((MyWorld)getWorld()).addScore(10); // used to add 10 score to the scoreboard when a target is touched
        }
    }
}
